const O=["vec2","vec2i","vec2u","vec2f","vec2h","vec3","vec3i","vec3u","vec3f","vec3h","vec4","vec4i","vec4u","vec4f","vec4h","mat2x2","mat2x2f","mat2x2h","mat2x3","mat2x3f","mat2x3h","mat2x4","mat2x4f","mat2x4h","mat3x2","mat3x2f","mat3x2h","mat3x3","mat3x3f","mat3x3h","mat3x4","mat3x4f","mat3x4h","mat4x2","mat4x2f","mat4x2h","mat4x3","mat4x3f","mat4x3h","mat4x4","mat4x4f","mat4x4h","array","atomic","bool","f32","f16","i32","ptr","sampler","sampler_comparison","texture_1d","texture_2d","texture_2d_array","texture_3d","texture_cube","texture_cube_array","texture_multisampled_2d","texture_storage_1d","texture_storage_2d","texture_storage_2d_array","texture_storage_3d","texture_depth_2d","texture_depth_2d_array","texture_depth_cube","texture_depth_cube_array","texture_depth_multisampled_2d","u32","alias","bitcast","break","case","const","const_assert","continue","continuing","default","discard","else","enable","false","fn","for","if","let","loop","override","return","struct","switch","true","var","while","Hullshader","NULL","Self","abstract","active","alignas","alignof","as","asm","asm_fragment","async","attribute","auto","await","become","bf16","binding_array","cast","catch","class","co_await","co_return","co_yield","coherent","column_major","common","compile","compile_fragment","concept","const_cast","consteval","constexpr","constinit","crate","debugger","decltype","delete","demote","demote_to_helper","do","dynamic_cast","enum","explicit","export","extends","extern","external","f64","fallthrough","filter","final","finally","friend","from","fxgroup","get","goto","groupshared","handle","highp","i16","i64","i8","impl","implements","import","inline","instanceof","interface","layout","lowp","macro","macro_rules","match","mediump","meta","mod","module","move","mut","mutable","namespace","new","nil","noexcept","noinline","nointerpolation","noperspective","null","nullptr","of","operator","package","packoffset","partition","pass","patch","pixelfragment","precise","precision","premerge","priv","protected","pub","public","quat","readonly","ref","regardless","register","reinterpret_cast","requires","resource","restrict","self","set","shared","sizeof","smooth","snorm","static","static_assert","static_cast","std","subroutine","super","target","template","this","thread_local","throw","trait","try","type","typedef","typeid","typename","typeof","u16","u64","u8","union","unless","unorm","unsafe","unsized","use","using","varying","virtual","volatile","wgsl","where","with","writeonly","yield","@align","@binding","@builtin","@compute","@const","@fragment","@group","@id","@interpolate","@invariant","@location","@size","@vertex","@workgroup_size","perspective","linear","flat","center","centroid","sample","vertex_index","instance_index","position","front_facing","frag_depth","local_invocation_id","local_invocation_index","global_invocation_id","workgroup_id","num_workgroups","sample_index","sample_mask","read","write","read_write","function","private","workgroup","uniform","storage","rgba8unorm","rgba8snorm","rgba8uint","rgba8sint","rgba16uint","rgba16sint","rgba16float","r32uint","r32sint","r32float","rg32uint","rg32sint","rg32float","rgba32uint","rgba32sint","rgba32float","bgra8unorm","f16","all","any","select","arrayLength","abs","acos","acosh","asin","asinh","atan","atanh","atan2","ceil","clamp","cos","cosh","countLeadingZeros","countOneBits","countTrailingZeros","cross","degrees","determinant","distance","dot","exp","exp2","extractBits","faceForward","firstLeadingBit","firstTrailingBit","floor","fma","fract","frexp","insertBits","inverseSqrt","ldexp","length","log","log2","max","min","mix","modf","normalize","pow","quantizeToF16","radians","reflect","refract","reverseBits","round","saturate","sign","sin","sinh","smoothstep","sqrt","step","tan","tanh","transpose","trunc","dpdx","dpdxCoarse","dpdxFine","dpdy","dpdyCoarse","dpdyFine","fwidth","fwidthCoarse","fwidthFine","textureDimensions","textureGather","textureGatherCompare","textureLoad","textureNumLayers","textureNumLevels","textureNumSamples","textureSample","textureSampleBias","textureSampleCompare","textureSampleCompareLevel","textureSampleGrad","textureSampleLevel","textureSampleBaseClampToEdge","atomicLoad","atomicStore","atomicAdd","atomicSub","atomicMax","atomicMin","atomicAnd","atomicOr","atomicXor","atomicExchange","atomicCompareExchangeWeak","pack4x8snorm","pack4x8unorm","pack2x16snorm","pack2x16unorm","pack2x16float","unpack4x8snorm","unpack4x8unorm","unpack2x16snorm","unpack2x16unorm","unpack2x16float","storageBarrier","workgroupBarrier","workgroupUniformLoad"],T=["const","uniform","layout","centroid","flat","smooth","break","continue","do","for","while","switch","case","default","if","else","in","out","inout","float","int","void","bool","true","false","invariant","discard","return","mat2","mat3","mat4","mat2x2","mat2x3","mat2x4","mat3x2","mat3x3","mat3x4","mat4x2","mat4x3","mat4x4","vec2","vec3","vec4","ivec2","ivec3","ivec4","bvec2","bvec3","bvec4","uint","uvec2","uvec3","uvec4","lowp","mediump","highp","precision","sampler2D","sampler3D","samplerCube","sampler2DShadow","samplerCubeShadow","sampler2DArray","sampler2DArrayShadow","isampler2D","isampler3D","isamplerCube","isampler2DArray","usampler2D","usampler3D","usamplerCube","usampler2DArray","struct","attribute","varying","coherent","volatile","restrict","readonly","writeonly","resource","atomic_uint","noperspective","patch","sample","subroutine","common","partition","active","asm","class","union","enum","typedef","template","this","goto","inline","noinline","volatile","public","static","extern","external","interface","long","short","double","half","fixed","unsigned","superp","input","output","hvec2","hvec3","hvec4","dvec2","dvec3","dvec4","fvec2","fvec3","fvec4","sampler3DRect","filter","image1D","image2D","image3D","imageCube","iimage1D","iimage2D","iimage3D","iimageCube","uimage1D","uimage2D","uimage3D","uimageCube","image1DArray","image2DArray","iimage1DArray","iimage2DArray","uimage1DArray","uimage2DArray","imageBuffer","iimageBuffer","uimageBuffer","sampler1D","sampler1DShadow","sampler1DArray","sampler1DArrayShadow","isampler1D","isampler1DArray","usampler1D","usampler1DArray","sampler2DRect","sampler2DRectShadow","isampler2DRect","usampler2DRect","samplerBuffer","isamplerBuffer","usamplerBuffer","sampler2DMS","isampler2DMS","usampler2DMS","sampler2DMSArray","isampler2DMSArray","usampler2DMSArray","sizeof","cast","namespace","using","#define","#undef","#if","#ifdef","#ifndef","#else","#elif","#endif","#error","#pragma","#extension","#version","#line","defined","__LINE__","__FILE__","__VERSION__","GL_ES","gl_VertexID","gl_InstanceID","gl_Position","gl_PointSize","gl_FragCoord","gl_FrontFacing","gl_FragDepth","gl_PointCoord","gl_MaxVertexAttribs","gl_MaxVertexUniformVectors","gl_MaxVertexOutputVectors","gl_MaxFragmentInputVectors","gl_MaxVertexTextureImageUnits","gl_MaxCombinedTextureImageUnits","gl_MaxTextureImageUnits","gl_MaxFragmentUniformVectors","gl_MaxDrawBuffers","gl_MinProgramTexelOffset","gl_MaxProgramTexelOffset","gl_DepthRangeParameters","gl_DepthRange","radians","degrees","sin","cos","tan","asin","acos","atan","sinh","cosh","tanh","asinh","acosh","atanh","pow","exp","log","exp2","log2","sqrt","inversesqrt","abs","sign","floor","trunc","round","roundEven","ceil","fract","mod","modf","min","max","clamp","mix","step","smoothstep","isnan","isinf","floatBitsToInt","floatBitsToUint","intBitsToFloat","uintBitsToFloat","packSnorm2x16","unpackSnorm2x16","packUnorm2x16","unpackUnorm2x16","packHalf2x16","unpackHalf2x16","length","distance","dot","cross","normalize","faceforward","reflect","refract","matrixCompMult","outerProduct","transpose","determinant","inverse","lessThan","lessThanEqual","greaterThan","greaterThanEqual","equal","notEqual","any","all","not","textureSize","texture","textureProj","textureLod","textureOffset","texelFetch","texelFetchOffset","textureProjOffset","textureLodOffset","textureProjLod","textureProjLodOffset","textureGrad","textureGradOffset","textureProjGrad","textureProjGradOffset","dFdx","dFdy","fwidth","#include","gl_DrawID","gl_ViewID_OVR","GL_OVR_multiview2"],I=["//","/*","*/",":",",",".","{","[","(","?","}","]",")",";","~","--","++","!","&","|","^","/","==",">",">=","<","<=","&&","||","^^","-","*","!=","+","%","<<",">>","=","+=","&=","|=","^=","/=","*=","%=","<<=",">>=","-="],P=[...I,"#","\\"],G=[...I,"->","@"],K=RegExp.prototype.test.bind(/\bfn\s+\w+\s*\(|\b(var|let)\s+\w+\s*[:=]/),V=RegExp.prototype.test.bind(/^(\d+\.\d*|\d*\.\d+)([eEpP][-+]?\d+)?[fFhH]?$/),X=RegExp.prototype.test.bind(/^(0[xX][\w\d]+|\d+)[iIuU]?$/),J=RegExp.prototype.test.bind(/^(true|false)$/),Q=48,ee=57,te=65,ae=90,re=10,ie=13,oe=9,ne=32,le=95,z=47,q=42,se=35,ue=64,U=e=>Q<=e&&e<=ee,me=e=>(e&=-33,te<=e&&e<=ae),pe=e=>e===re||e===ie,j=e=>pe(e)||e===oe||e===ne,W=e=>me(e)||U(e)||e===le,ce=e=>e===se||e===ue;function N(e,i=0){const n=[];let p=-1;const[c,d]=K(e)?[O,G]:[T,P];for(;i<e.length;){let a=e[i];const s=e.charCodeAt(i++);if(j(s)){for(;j(e.charCodeAt(i));)a+=e[i++];n.push({type:"whitespace",value:a})}else if(U(s)){for(;V(a+e[i])||X(a+e[i]);)a+=e[i++];V(a)?n.push({type:"float",value:a}):n.push({type:"int",value:a})}else if(W(s)){for(;W(e.charCodeAt(i));)a+=e[i++];J(a)?n.push({type:"bool",value:a}):c.includes(ce(p)?String.fromCharCode(p)+a:a)?n.push({type:"keyword",value:a}):n.push({type:"identifier",value:a})}else if(s===z&&(e.charCodeAt(i)===z||e.charCodeAt(i)===q)){const u=e.charCodeAt(i)===q?"*/":`
`;for(;!a.endsWith(u);)a+=e[i++];n.push({type:"comment",value:a})}else{for(const u of d)u.length>a.length&&e.startsWith(u,i-1)&&(a=u);i+=a.length-1,n.push({type:"symbol",value:a})}p=s}return n}const $=RegExp.prototype.test.bind(/^\w/),de=RegExp.prototype.test.bind(/[^\w\\]/),H=RegExp.prototype.test.bind(/^[_A-Za-z]/),Y=RegExp.prototype.test.bind(/^(binding|group|layout|uniform|in|out|attribute|varying|,)$/);function fe(e,{mangle:i=!1,mangleMap:n=new Map,mangleExternals:p=!1}={}){var c,d,a,s,u,g,v,h,_,y,b,D,w,S,k,C,L,A,M;e=e.replace(/(^\s*#[^\\]*?)(\n|\/[\/\*])/gm,"$1\\$2");const B=new Map,Z=new Set(n.values()),r=N(e).filter(t=>t.type!=="whitespace"&&t.type!=="comment");let E=0,x=null,m="";for(let t=0;t<r.length;t++){const o=r[t];if($(o.value)&&$((c=r[t-1])==null?void 0:c.value)&&(m+=" "),o.value==="{"&&H((d=r[t-1])==null?void 0:d.value)?x=t-1:o.value==="}"&&(x=null),de(o.value)&&(((a=r[t-2])==null?void 0:a.value)==="#"&&((s=r[t-1])==null?void 0:s.value)==="include"||((u=r[t-3])==null?void 0:u.value)==="#"&&((g=r[t-2])==null?void 0:g.value)==="define")&&(m+=" "),o.type==="identifier"&&o.value!=="main"&&(typeof i=="boolean"?i:i(o,t,r))){const R=((v=r[t-1])==null?void 0:v.value)==="}"&&((h=r[t+1])==null?void 0:h.value)===";",F=Y((_=r[t-1])==null?void 0:_.value)||Y((y=r[t-2])==null?void 0:y.value);let l=(b=n.get(o.value))!=null?b:B.get(o.value);if(!l&&x==null&&(H((D=r[t-1])==null?void 0:D.value)||R||((w=r[t-1])==null?void 0:w.value)===","||((S=r[t+1])==null?void 0:S.value)===":")&&(p||!F)){for(;!l||Z.has(l);){l="",E++;let f=E;for(;f>0;)l=String.fromCharCode(97+(f-1)%26)+l,f=Math.floor(f/26)}(p&&F||((k=r[t-2])==null?void 0:k.value)==="#"||R||((C=r[t-1])==null?void 0:C.value)==="fn"&&(((L=r[t-2])==null?void 0:L.value)===")"||((A=r[t-3])==null?void 0:A.value)==="@")?n:B).set(o.value,l)}m+=l!=null?l:o.value}else o.value==="#"&&((M=r[t-1])==null?void 0:M.value)!=="\\"?m+=`
#`:o.value==="\\"?m+=`
`:m+=o.value}return m.trim()}export{T as GLSL_KEYWORDS,P as GLSL_SYMBOLS,O as WGSL_KEYWORDS,G as WGSL_SYMBOLS,fe as minify,N as tokenize};
//# sourceMappingURL=index.js.map
